#include <stdio.h>
#include <stdlib.h>
#include "jflib.c"
#define n18 50
#define mnp 50000                       //  50,000 points make pic

// int  dumi[50];
// float m0[120],m1[30];
char sa[50],sb[50],sc[50];              // 3 label
char a[255],f1[80],fload[80],b[80];
char h1[72][80];
int ppar[n18+1],npar;                   // n18+1 is strlen(cc)
int han[n18];                           //
float lx[n18/2],ly[n18/2];              // line(n,ax,ay);
double a8[8],b8[8];
double pi,cx,cy;
char c1[14],c2[14];

main(int ac, char **av)
{
  int i,j,k,i1,j1;
  float x,y,z,x1,y1;
  char *cc,c;
  FILE *fp;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
    
  if(ac<2){
    printf("\n\t\t*** JFPLOT ***  Usage: jf *[.jf] [!] ***v1***\n\n");
printf("\tA    : x,y,GBcode...                NextC: command_string\n");
printf("\tBegin: Pixel_X,Y,Edge,[file,x,y]    Origi: world/pixel | 0/1\n");
printf("\tColor: n (0~15,..240,..)            Q    : point_style (-22~22)\n");
printf("\tDone : None                         Size : GBcode: 16 | 24 | 48\n");
printf("\tEnv  : x1,x2,y1,y2,[2,0~9]                 Gap: 0~9\n");
printf("\tFitsT: 8 | 16 | 32                         test_size: 11 | 10\n");
printf("\tGb_la: stringX,strY,strTop                 Direction: 12 | 13\n");
printf("\t       strX,strY,GBcode...          Text : x,y,string\n");
printf("\tKeyWo: keyword = string             Versi: None\n");
printf("\tLine : x1 y1,x2 y2,...              Width: n (1~3, line width)\n");
printf("\tHisto:  x,y\n");
printf("\t        file,-x n,-y n,[-z n,-r x1 x2,-t n]\n");
printf("\tPoint:  x,y\n");
printf("\t        file,-x n,-y n,[-z n,-r x1 x2,-t n,-c n]\n");
printf("\tImage0: x,y,file                            (fitstype=8)\n");
printf("\tImage1: x,y file,centX,centY,sizeX,[sizeY]  (fitstype=16|32)\n");
printf("\tImageN: developing!!\n\n");
    exit(0);
  }
  strcpy(f1,av[1]); k=strlen(f1);
  for(i=0;i<k;i++)if(f1[i]=='.')break;
  sprintf(&f1[i],".jf");
  fp=fopen(f1,"r"); if(!fp){ printf("\t%s not found!\n",f1); exit(0); }
l10:
  fgets(a,255,fp); if(feof(fp))goto l20;
  if(ac>2)printf("%s",a);
  if(a[0]!='#')goto l10;                  //  ## or // are comment line
  c=a[1]|0x20;                            //  A-->a
  if(c=='#')goto l10;
  if(c=='v'){                                    jfdate(); goto l10; }
  if(c=='d'){ jfend();
    if(jf_ty==8){ sprintf(b,"g6 %s -c -t",f1); system(b);  }
    jf_init();                                              goto l10; }
  j=cleanline(a,&npar);                   // j: 1st!=32 column; npar: ? gap
  cc=&a[j];
  if(c=='a'){                             // jfchina(x,y,a,n)
    sscanf(cc,"%f %f",&x,&y);  k=npar-2;  //read: x,y,han...
    for(i=0;i<k;i++){ sscanf(&cc[ppar[i+2]],"%f",&z); han[i]=z; }
                 jfchina(x,y,han,k);                        goto l10; }
  if(c=='b'){
    sscanf(cc,"%s %f %f %f %s %f %f",f1,&x,&y,&z,fload,&x1,&y1);
    if(npar<=4)fload[0]=0; else { delc34(fload); fname(fload,"bmp"); }
    delc34(f1); fname(f1,"fit");  i=x; j=y; k=z; i1=x1; j1=y1;
    if(strlen(fload)){ fp=fopen(fload,"r");
      if(!fp){ printf("%s\n---Warn %s not found!\n",a,fload); fload[0]=0; }
      else fclose(fp);
    }
    if(npar<=3)k=50;                      // assume edge
    if(npar<=2)j=i*3/4;                   // assume jf_jlen
    jfbegin(f1,i,j,k,fload,i1,j1);                          goto l10; }
  if(c=='c'){ sscanf(cc,"%f",&x); i=x; jfsci(i);            goto l10; }
  if(c=='e'){
    if(j==0){ x=0; x1=jf_ilen; y=0; y1=jf_jlen; k=2; }
    else {
      sscanf(cc,"%f %f %f %f %f",&x,&x1,&y,&y1,&z);
      k=z; if(npar<=4)k=2;  if(k>8)k=8;   // assume frame_tick
    }     jfenv(x,x1,y,y1,k);                                goto l10; }
  if(c=='f'){ sscanf(cc,"%f",&x); i=x;
    if(i!=8 && i!=16 && i!=32){
      printf("%s\n***err Wrong fits_type, 8,16,32 only!\n",a); exit(0); }
                                       jfsfitype(i);        goto l10; }
  if(c=='g'){
    for(i=k=0;i<strlen(cc);i++)if(cc[i]=='"')han[k++]=i;
    if(k%2){ printf("%s\n***err quato number wrong, now=%d",a,k); exit(0); }
    j=0; for(i=ppar[0];i<ppar[1];i++)sa[j++]=cc[i]; sa[j]=0;
    j=0; for(i=ppar[1];i<ppar[2];i++)sb[j++]=cc[i]; sb[j]=0;
    j=0; for(i=ppar[2];i<ppar[3];i++)sc[j++]=cc[i]; sc[j]=0;
    delc34(sa); delc34(sb); delc34(sc);
    if(npar<=3){ jfalabel(sa,sb,sc);                        goto l10; }
    k=npar-2;
    for(i=0;i<k;i++){ sscanf(&cc[ppar[i+2]],"%f",&z); han[i]=z; }
                 jfhlabel(sa,sb,han,k);                     goto l10; }
  if(c=='i'){ j--; while(a[j]==32)j--;
    if(a[j]=='0')image0(cc,&jf.buf4[jf_em]); 
    if(a[j]=='1')image1(cc,&jf.buf4[jf_em],&jf.buf4[jf_em],&jf.buf4[jf_em]); 
                                                            goto l10; }
  if(c=='k'){
    if(jf_fhp>=71){printf("%s\n***err fits_head full\n",a); goto l10; }
    for(i=j=0;i<9;i++)if(cc[i]=='='){ j=i; break; }
    k=strlen(cc); if(k>70){ k=70; cc[k]=0; }
    if(j==0){
      sprintf(head[jf_fhp],"comment %s",cc); head[jf_fhp][k+8]=32;
    } else {
      for(j=0;j<i;j++)head[jf_fhp][j]=cc[j]; head[jf_fhp][8]='=';
      while(cc[i++]==32); k=strlen(&cc[i]); j=30-k; if(j<9)j=9;
      for(i1=j;i1<j+k;i1++)head[jf_fhp][i1]=cc[i++];
    } jf_fhp++;                                           goto l10; }
  if(c=='l'){
    for(i=0;i<npar/2;i++)sscanf(&cc[ppar[i*2]],"%f %f",&lx[i],&ly[i]);
//for(i=0;i<40;i++)printf("%d",i%10); printf("\n"); printf("%s\n",cc);
//for(i=0;i<=npar;i++)printf("%d ",ppar[i]); printf("\n");
//for(i=0;i<npar/2;i++)printf("%5.1f %5.1f   ",lx[i],ly[i]); printf("\n");
    jfline(npar/2,lx,ly);                                 goto l10; }
  if(c=='n'){ delc34(cc); system(cc);                     goto l10; }
  if(c=='o'){
    if(cc[i]<='9'){ sscanf(cc,"%f",&x); k=x; }
    else k=(cc[i]|0x20=='w')?0:1;  jfscoord(k);           goto l10; }
  if(c=='p'|| c=='h'){
    k=1; if(c=='h')k=0;
    if(npar==2){ sscanf(cc,"%f %f",&x,&y);
                 if(k)jfpoint(x,y); else jfhist(x,y);     goto l10; }
    point0(cc,&jf.buf4[jf_em],&jf.buf4[jf_em+mnp],&jf.buf4[jf_em+2*mnp],k);
    goto l10;
  }
  if(c=='q'){ sscanf(cc,"%f",&x);  i=x;
    if(i<-22 || i>22){ printf("%s\n***err point type -22~22\n",a); exit(0); }
                                        jfspoint(i);      goto l10; }
  if(c=='s'){ sscanf(cc,"%f",&x);  i=x;
    if(i>=16){
      if(i!=16 && i!=24 && i!=48){
      printf("%a***err haizi type=16,24,48\n",a); exit(0); }
    } else {
      if(i<0 || i>13){
      printf("%s\n***err gap 0~9, text_size 10~11, direct 12~13\n",a);exit(0);}
    }                                   jfsize(i);        goto l10; }
  if(c=='t'){ sscanf(cc,"%f %f",&x,&y);
    j=0; for(i=ppar[2];i<ppar[3];i++)b[j++]=cc[i]; b[j]=0;
       delc34(b); jftext(x,y,b);                          goto l10; }
  if(c=='w'){ sscanf(cc,"%f",&x); i=x;
    if(i<0 || i>3){ printf("%s\n***err line width =1,2,3\n",a); exit(0); }
                                       jfslw(i);          goto l10; }
  goto l10;
l20:
  fclose(fp); jfend();
  if(jf_ty==8){ sprintf(b,"g6 %s -c -t",f1); system(b); }
}

point0(cc,ax,ay,am,ph)
char *cc; float *ax,*ay; int *am,ph;
{
  int i,j,k1,k2,n, lx,ly,lu,lv,lc,lr;
  char f1[30],c,a[255]; FILE *fp;
  float x,y,z,r1,r2,t,az[4];
  sscanf(cc,"%s",f1); delc34(f1);
  j=1;  lx=ly=lu=lv=lc=lr=t=0;
l10:
  for(i=ppar[j];i<ppar[npar];i++)if(cc[i]=='-')break;
  if(i>=ppar[npar])goto l20;
  c=cc[i+1]|0x20;
  if(c=='x'){ sscanf(&cc[i+2],"%f",&z);  lx=z; }
  if(c=='y'){ sscanf(&cc[i+2],"%f",&z);  ly=z; }
  if(c=='u'){ sscanf(&cc[i+2],"%f",&z);  lu=z; }
  if(c=='v'){ sscanf(&cc[i+2],"%f",&z);  lv=z; }
  if(c=='c'){ sscanf(&cc[i+2],"%f",&z);  lc=z; }
  if(c=='t')  sscanf(&cc[i+2],"%f",&t);
  if(c=='r'){ sscanf(&cc[i+2],"%f %f",&r1,&r2); j++; lr=1; }
  j+=2;
  goto l10;
l20:
  if(lx==0){ printf("***err not found -X par.\n"); exit(0); }
  if(ly==0){ printf("***err not found -Y par.\n"); exit(0); }
  fp=fopen(f1,"r"); if(!fp){ printf("***err %s not found!\n",f1); exit(0); }
  k1=n=0; if(r1==r2)lr=0; if(r1>r2){ z=r1; r1=r2; r2=z; }
  lx--; ly--; 
l30:
  fgets(a,255,fp); if(feof(fp))goto l40;
  if(a[0]=='#')goto l30;  k1++;
  sscanf(&a[lx],"%f",&x); if(x==0.)goto l30;
  sscanf(&a[ly],"%f",&y); if(y==0.)goto l30;
  if(lu){ sscanf(&a[lu-1],"%f",&z); if(z==0.)goto l30; x-=z; }
  if(lv){ sscanf(&a[lv-1],"%f",&z); if(z==0.)goto l30; y-=z; }
  if(ph)jfpoint(x,y); else jfhist(x,y);
  if(lr)if(x>r1 && x<r2){ ax[n]=x; ay[n]=y; am[n]=1; n++; if(n==mnp)n--; }
  goto l30;
l40:
  fclose(fp); k2=n;
  printf("---%s: all points: %d  ranged: %d (%5.2f~%5.2f)",f1,k1,k2,r1,r2);
  if(t==0)printf("\n"); else printf("  turn:%7.3f\n",t);
  if(lr==0)return;
  yabx(ax,ay,am,t,n,az);
  if(lc){
    j=jf_deep; jfsci(lc);
    x=az[0]; y=az[2];
    az[0]=r1; az[1]=r2; az[2]=x*r1+y; az[3]=x*r2+y;
    jfline(2,az,&az[2]); jf_deep=j;
  }
}

yabx(ax,ay,am,t,n,az)
float *ax,*ay,*az,t; int *am,n;
{
  float x,y,xx,xy,a,b,as,bs;
  float s3;
  int i,j,k=0,m;
l10:  k++;
  x=y=xx=xy=m=0;
  for(i=0;i<n;i++)if(am[i]){ m++;
    a=ax[i]; b=ay[i];
    x+=a;    y+=b;
    xx+=a*a; xy+=a*b;
  }
  as=m;
  bs=as*xx-x*x;
  a=(as*xy-x*y)/bs;
  b=(y-a*x)/as;
  x=0;
  for(i=0;i<n;i++)if(am[i]){ y=ax[i]*a+b-ay[i]; x+=y*y; }
  x/=(as-2.);
  as=sqrt(as/bs*x);
  bs=sqrt(xx/bs*x);
  printf("---points:%6d    A:%7.3f (%5.3f)    B:%7.3f (%5.3f)\n",m,a,as,b,bs);
  s3=sqrt(as*as+bs*bs)*3.;
  for(i=j=0;i<n;i++)if(am[i]){
    y=ax[i]*a+b-ay[i]; if(y<0.)y=-y;
    if(y>s3){ am[i]=0; j++; }
  }
  if(j==0)goto l20;                   // no 3sigma points
  if(t!=0.){
    if(t>=1. && t<=k)goto l20;
    if(t<1. && as<t && bs<t)goto l20;
  }
  goto l10;
l20:
  az[0]=a; az[1]=as; az[2]=b; az[3]=bs;
}

getxy(jx,jy,bok)
int *jx,*jy;
{
  int i,j,k;
  double ra,de,x,y;
  k=hindex(h1,"A81      ",72);
  if(k==72)return 1;
  for(i=0;i<8;i++)sscanf(&h1[k+i][10],"%lf",&a8[i]); hxytoad(a8,b8);
  hchs(c1,&ra); hchs(c2,&de);
  hrad_xy(a8[6],a8[7],ra,de,&x,&y,bok+1,0);     // 1 schmidt  2 bok
//printf("%s %s %lf %lf  %lf %lf\n",c1,c2,ra,de,x,y);
//xy_rad(a8[6],a8[7],dx,dy,&alpha,&delta,1,0);
  *jx=x+0.5; *jy=y+0.5;
  return 0;  
}

image1(a,r4,i2,b1)
char *a; float *r4; unsigned short *i2; unsigned char *b1;
{
  int i,j,k, n1,n2, ix,iy,jx,jy,kx,ky,ty,bzero=0;
  float x,y,u,v=0; char f1[30]; FILE *fp;
  sscanf(a,"%f %f %s %s %s %f %f",&x,&y,f1,c1,c2,&u,&v);
  delc34(f1); fname(f1,"fit"); ix=x; iy=y; kx=u; ky=(v==0.)?u:v;
  fp=fopen(f1,"rb"); if(!fp){ printf("***err %s not found!\n",f1); exit(0); }
  fread(h1,72,80,fp);
  k=hindex(h1,"BITPIX  ",72); sscanf(&h1[k][20],"%d",&ty); if(ty<0)ty=-ty;
  k=hindex(h1,"NAXIS1  ",72); sscanf(&h1[k][20],"%d",&n1);
  k=hindex(h1,"NAXIS2  ",72); sscanf(&h1[k][20],"%d",&n2);
  j=0; if(n1==4096 && n2==4032)j=1;               // bok data
  k=0; for(i=0;i<strlen(c1);i++)if(c1[i]==':')k++;
  if(k){ j=getxy(&jx,&jy,j); 
    if(j){ printf("\n%s unknown coordination\n",f1); fclose(fp); exit(0); }}
  else { sscanf(c1,"%f",&x); jx=x+0.5; sscanf(c2,"%f",&y); jy=y+0.5; }
//printf("%d %s %s  %f %f   %d %d\n",k,c1,c2,x,y,jx,jy);
  jx-=kx/2; jy-=ky/2;
  if(ty==16){
      k=hindex(h1,"BZERO   ",72); if(k!=72)sscanf(&h1[k][20],"%d",&bzero); }
  while(hindex(h1,"END     ",72)==72)fread(h1[36],36,80,fp);
  if(jf_ty==32){
    if(ty==32){
      for(j=0;j<jy;j++)fread(r4,4,n1,fp);
      for(j=0;j<ky;j++){ fread(r4,4,n1,fp); swap_4(r4,4*n1);
        k=(iy+j+jf_edge)*jf_n1+jf_edge+ix;
        for(i=jx;i<jx+kx;i++)jf.buf4[k++]=r4[i];
      }
    }
    if(ty==16){
      for(j=0;j<jy;j++)fread(i2,2,n1,fp);
      for(j=0;j<ky;j++){ fread(i2,2,n1,fp); swap_2(i2,2*n1);
        k=(iy+j+jf_edge)*jf_n1+jf_edge+ix;
        for(i=jx;i<jx+kx;i++)jf.buf4[k++]=(i2[i]+bzero)&0xffff;
      }
    }
    if(ty==8){
      for(j=0;j<jy;j++)fread(b1,1,n1,fp);
      for(j=0;j<ky;j++){ fread(b1,1,n1,fp); 
        k=(iy+j+jf_edge)*jf_n1+jf_edge+ix;
        for(i=jx;i<jx+kx;i++)jf.buf4[k++]=b1[i];
      }
    }
  } 
//----------------------------
  if(jf_ty==16){
    if(ty==32){
      for(j=0;j<jy;j++)fread(r4,4,n1,fp);
      for(j=0;j<ky;j++){ fread(r4,4,n1,fp); swap_4(r4,4*n1);
        k=(iy+j+jf_edge)*jf_n1+jf_edge+ix;
        for(i=jx;i<jx+kx;i++)jf.buf2[k++]=r4[i]+0.5;
      }
    }
    if(ty==16){
      for(j=0;j<jy;j++)fread(i2,2,n1,fp);
      for(j=0;j<ky;j++){ fread(i2,2,n1,fp); swap_2(i2,2*n1);
        k=(iy+j+jf_edge)*jf_n1+jf_edge+ix;
        for(i=jx;i<jx+kx;i++)jf.buf2[k++]=i2[i]+bzero;
      }
    }
    if(ty==8){
      for(j=0;j<jy;j++)fread(b1,1,n1,fp);
      for(j=0;j<ky;j++){ fread(b1,1,n1,fp);
        k=(iy+j+jf_edge)*jf_n1+jf_edge+ix;
        for(i=jx;i<jx+kx;i++)jf.buf2[k++]=b1[i];
      }
    }
  }
  fclose(fp);
}

image0(char *a,char *dumc)
{
  int i,j,k, n1,n2, ix,iy; float x,y; char f1[30]; FILE *fp;
  sscanf(a,"%f %f %s",&x,&y,f1); delc34(f1); fname(f1,"fit"); ix=x; iy=y;
  fp=fopen(f1,"rb"); if(!fp){ printf("***err %s not found!\n",f1); exit(0); }
  fread(h1,36,80,fp);
  k=hindex(h1,"BITPIX  ",36); sscanf(&h1[k][20],"%d",&k);
  if(k!=8){ printf("***err Image0 only process 8_bit fits %s\n",f1);exit(0);}
  k=hindex(h1,"NAXIS1  ",36); sscanf(&h1[k][20],"%d",&n1);
  k=hindex(h1,"NAXIS2  ",36); sscanf(&h1[k][20],"%d",&n2);
  while(hindex(h1,"END     ",36)==36)fread(h1,36,80,fp);
  for(j=0;j<n2;j++){
    fread(dumc,1,n1,fp);
    k=(iy+j+jf_edge)*jf_n1+jf_edge+ix;
    for(i=0;i<n1;i++)jf.buf1[k++]=dumc[i];
  } fclose(fp);
}

hindex(h,a,nh)
char h[][80],*a; int nh;
{
  int i,j;
  for(i=0;i<nh;i++){
    for(j=0;j<8;j++)if(h[i][j]!=a[j])goto l10;
    return i;
l10:
    continue;
  } return i;
}

delc34(char *a)
{
  int k;                                     // 1st 32+";   last "
  k=0; while(a[k]==32)k++;
  if(a[k]==34)k++;
  strcpy(b,&a[k]); strcpy(a,b);
  k=strlen(a)-1; if(a[k]==34)a[k]=0;
}

cleanline(char *a,int *npar)
{
  int i1,i,j,j1,k,c34=0;
  k=strlen(a)-1; a[k]=0;
  for(i=2;i<k;i++)if(a[i]==',')a[i]=32;
  for(i=2;i<k;i++)if(a[i]=='/' && a[i+1]=='/'){ a[i]=0; break; }
  k=strlen(a); while(a[k-1]==32)k--; a[k]=0;
  for(i=2;i<k;i++)if(a[i]==32)break;
  if(i>=k)return(0);
  while(a[i]==32)i++;
  i1=i; j=j1=1;
  for(i=i1;i<k;i++){
    if(a[i]==34)c34++;
    if(a[i]==32 && j1==1 && c34%2==0)ppar[j++]=i-i1;
    if(a[i]==32)j1=0; else j1=1;
  } *npar=j; ppar[j]=k-i1; ppar[0]=0;
  return(i1);
}

fname(char *a, char *d)
{
  int i;
  for(i=0;i<strlen(a);i++)if(a[i]=='.'){ a[i]=0; break; }
  sprintf(b,"%s.%s",a,d); strcpy(a,b);
}

hxytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
hrad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

hxy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

htoms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

hchs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strncpy(b,a,14); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

